import React, { type FC, type ReactNode } from "react";
type ProviderProps = {
    children?: ReactNode;
};
type Result<TValue, TName extends string> = {
    [K in `use${TName}` | `${TName}Provider` | `with${TName}`]: K extends `use${TName}` ? () => TValue : K extends `${TName}Provider` ? FC<ProviderProps> : K extends `with${TName}` ? <TProps extends object>(WrappedComponent: React.ComponentType<TProps>) => (props: TProps) => JSX.Element : never;
};
declare function typesafeContextHook<TName extends string, TValue = any>(name: TName, hook: () => TValue): Result<TValue, TName>;
export default typesafeContextHook;
