"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
function typesafeContextHook(name, hook) {
    const Context = (0, react_1.createContext)(null);
    const Provider = ({ children }) => {
        const value = hook();
        return (0, jsx_runtime_1.jsx)(Context.Provider, { value: value, children: children });
    };
    function useNamedCustomHook() {
        const value = (0, react_1.useContext)(Context);
        if (value === null) {
            throw new Error(`use${name} must be used within a ${name}Provider`);
        }
        return value;
    }
    function withHook(WrappedComponent) {
        return function WrappedWithHook(props) {
            return ((0, jsx_runtime_1.jsx)(Provider, { children: (0, jsx_runtime_1.jsx)(WrappedComponent, Object.assign({}, props)) }));
        };
    }
    return {
        [`use${name}`]: useNamedCustomHook,
        [`${name}Provider`]: Provider,
        [`with${name}`]: withHook,
    };
}
exports.default = typesafeContextHook;
